#!/usr/bin/php
<?php
error_reporting(0);

// Set time limit to indefinite execution
set_time_limit(0);

// Set the ip and port we will listen on
$address = 'class.sva.edu';
$port = 4001;
$max_clients = 10;
$msgList = Array("","","","","","","","","","");

// Array that will hold client information
$clients = Array();


// Create a TCP Stream socket
$sock = @socket_create(AF_INET,SOCK_STREAM,0) or die("Can't create socket.\n");
echo "Socket created, [$sock].\n";
//socket_setopt($sock, SOL_SOCKET, SO_REUSEADDR, 1);
// Bind the socket to an address/port
socket_bind($sock, $address, $port) or die('Could not bind to address');
// Start listening for connections
socket_listen($sock);

// Loop continuously
while (true) {
    // Setup clients listen socket for reading
    $read[0] = $sock;
    for ($i = 0; $i < $max_clients; $i++)
    {
        if ($client[$i]['sock']  != null)
            $read[$i + 1] = $client[$i]['sock'] ;
    }
    // Set up a blocking call to socket_select()
    $foo = null;
    $ready = socket_select($read,$foo,$foo,$foo);
    /* if a new connection is being made add it to the client array */
    if (in_array($sock, $read)) {
        for ($i = 0; $i < $max_clients; $i++)
        {
            if ($client[$i]['sock'] == null) {
                $client[$i]['sock'] = socket_accept($sock);
		print("accepting $i: ".$client[$i]['sock']."\n");
                break;
            }
            elseif ($i == $max_clients - 1)
                print ("too many clients");
        }
        if (--$ready <= 0)
            continue;
    } // end if in_array
    
    // If a client is trying to write - handle it now
    for ($i = 0; $i < $max_clients; $i++) // for each client
    {
        if (in_array($client[$i]['sock'] , $read))
        {
            $input = socket_read($client[$i]['sock'] , 1024);
            if ($input == null) {
		print("Zero length string meaning disconnected\n");
                unset($client[$i]);
            }
            $n = trim($input);
            if ($n == "exit") {
		print("requested disconnect: ".$client[$i]['sock']."\n");
                socket_close($client[$i]['sock']);
                unset($client[$i]);
            } else if ($input) {
                // strip some white spaces and add to the msgList 
                $output = ereg_replace("[\t\n\r]","",$input).chr(0);
		        $msgList[$i] = $output;
            }
        } else {
	    //send message to all
	    for($k=0;$k< $max_clients;$k++){
	      for($j=0;$j< $max_clients;$j++){
                socket_write($client[$j]['sock'],$msgList[$k]);
	      }
	      $msgList[$k]="";
	    }
        }
    }
} // end while
// Close the master sockets
socket_close($sock);
?> 
